<?xml version="1.0" encoding="UTF-8"?>
<!-- 	author: Mario Jeckle (mario.jeckle@daimlerchrysler.com, mario@jeckle.de, www.jeckle.de)
		last modification: 2000-12-08
		version: 1.2.1
-->

<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:lxslt="http://xml.apache.org/xslt" xmlns:counter="MyCounter"
	extension-element-prefixes="counter">

<lxslt:component prefix="counter" elements="incr" functions="read">
    <lxslt:script lang="javaclass" src="MyCounter" />
</lxslt:component>

<xsl:param name="n">1</xsl:param>
<xsl:param name="m">1</xsl:param>
<xsl:param name="max">0</xsl:param>

  <xsl:template match="/">
		<tree>
        <xsl:call-template name="node">
          <xsl:with-param name="m" select="$m" />
          <xsl:with-param name="max" select="$max" />
        </xsl:call-template>
		</tree>
	</xsl:template>

  <xsl:template name="node">
    <xsl:param name="m" />
    <xsl:param name="max">0</xsl:param>

	<xsl:if test="counter:read() &lt; $max or $max = 0">
		<node>
			<nodeInfo>ID<xsl:value-of select="counter:read()" /></nodeInfo>
			<counter:incr/>
			<xsl:call-template name="write">
				<xsl:with-param name="counter" select="1"/>
				<xsl:with-param name="limit" select="$n"/>
				<xsl:with-param name="m" select="$m"/>
				<xsl:with-param name="max" select="$max"/>
			</xsl:call-template>
		</node>
    </xsl:if>
  </xsl:template>

	<xsl:template name="write">
		<xsl:variable name="incr">1</xsl:variable>
		<xsl:variable name="decr">1</xsl:variable>

		<xsl:param name="counter"/>
		<xsl:param name="limit"/>
		<xsl:param name="m"/>
		<xsl:param name="max"/>

		<xsl:if test="$m != 0">
      	<xsl:call-template name="node">
         	<xsl:with-param name="m" select="$m - $decr" />
            <xsl:with-param name="max" select="$max"/>
         </xsl:call-template>
      </xsl:if>

		<xsl:if test="$counter &lt; $limit">
			<xsl:call-template name="write">
				<xsl:with-param name="counter" select="$counter + $incr"/>
				<xsl:with-param name="limit" select="$limit"/>
				<xsl:with-param name="m" select="$m"/>
				<xsl:with-param name="max" select="$max"/>
			</xsl:call-template>
		</xsl:if>
  	</xsl:template>
</xsl:stylesheet>